//////////////////////////////////////////////////////////////////////
//	$Date:: 2013-09-28 13:03:13 +0900#$
//	$Rev: 5692 $
//	Copyright (C) Hiroshi SUGIMURA 2013.09.27 - above.
//////////////////////////////////////////////////////////////////////

var fs = require('fs');
var Sil = require('./Sil');



//////////////////////////////////////////////////////////////////////
// AvP[VJ

// NXϐ
var App = {
outLevel: 3,																//< critical:0 ... log:5  nolog:-1
logfilename: "",
logType: "c",																//< "f", "c", "fc", "n" = file, console, file and console, none
timeStump: false,
opened: false
};

// 
App.initialize = function() {
	if( App.opened ) {
		App.logClose();
	}

	App.outLevel    = 3;														//< critical:0 ... log:5  nolog:-1
	App.logfilename = "";
	App.logType     = "c";														//< "f", "c", "fc", "n" = file, console, file and
	App.timeStump   = false;
	App.opened = false;
};


//////////////////////////////////////////////////////////////////////
// debug
//////////////////////////////////////////////////////////////////////

// O̕Wo
// critical:0 ... log:5
App.print = function ( level, log ) {

	if( level <= App.outLevel ) {
		App.output( log );
		return 1;
	}else{
		return 0;
	}
};


// O̕Wo
// critical:0 ... log:5
App.println = function ( level, log ) {
	// ^CX^vƂȂ
	if( App.timeStump == true ) {
		log = Sil.getDateString() + "-" + Sil.getTimeString() + log;
	}

	if( level <= App.outLevel ) {
		switch(level){
		case 5:		App.output("@@@@@@ " + log ); break;
		case 4:		App.output("@@@@@ " + log ); break;
		case 3:		App.output("@@@@ " + log ); break;
		case 2:		App.output("@@@ " + log ); break;
		case 1:		App.output("@@ " + log ); break;
		case 0:		App.output("@ " + log ); break;
		default:
			App.output( level );
		}
		return 1;
	} else {
		return 0;
	}
};



// CSV`̂悤ɃZp[g߂ďo
// logTable = [ [ xxx, ,..., xx], ... [
App.printCSV = function( level, logTable, delimita ) {
	if( level <= App.outLevel ) {

		logTable.forEach( function( row ){
			App.output( row.join(delimita) );
		});

		return 1;
	}else{
		return 0;
	}
};


// OcxύX
// critical:0 ... log:5  nolog:-1
App.setLevel = function (level) {
	if( -1 <= level && level <= 5 ) {
		App.outLevel = level;
		return 1;
	}else{
		print(0, "@ level set error - undef level" + level );
		return 0;
	}
};


// Oct@C߂
App.setLogfilename = function( filename ) {
	App.logfilename = filename;
};


// ^CX^vcȂtrueɂ
App.setTimeStump = function( flag ) {
	if( flag == 'true' ) {
		timeStump = true;
	}
};


// t@CɎcHWóH̗͂H߂
//             file, console,  file and console, none
// typestring = "f", "c", "fc", "n"
App.setLogType = function( typestring ) {
	switch( typestring ) {
	case "f" || "file":							logType = "f"; break;
	case "c" || "console" || "stdout":			logType = "c"; break;
	case "fc" || "cf" || "file and console":	logType = "fc"; break;
	case "n" || "none": 						logType = "n"; break;
	}
};


// o͂
App.output = function( str ) {
	// Ot@C܂ĂȂȂR\[Œ
	if( App.logfilename == "" ) {
		console.log( str );

	}else{
		switch( logType ) {
		case "c":
			console.log( str );
			break;
		case "f":
			App.fileoutput( str );
			break;
		case "fc":
			console.log( str );
			App.fileoutput( str );
			break;
		default:
		}
	}
};


// t@Co
App.fileoutput = function( str ) {
	if( !App.opened ) {
		fs.appendFile( App.logfilename, "> log start: " + Sil.getDateString() + "-" + Sil.getTimeString() + '\n' );
		App.opened = true;
	}
	fs.appendFile( App.logfilename, str + '\n' );
};


// OƂI
App.logClose = function() {
	if( App.opened ) {
		fs.appendFile( App.logfilename, "> log end: " + Sil.getDateString() + "-" + Sil.getTimeString() + '\n' );
	}

	App.opened = false;
};


module.exports = App;


//////////////////////////////////////////////////////////////////////
// EOF
//////////////////////////////////////////////////////////////////////
